/*
*
*	Lunar Note BETA
*
*/

#include "note.h"
#include <lunar/fx.hpp>

#define MAX_TRACKS 16

class note : public lunar::fx<note> {
public:

	struct trackdat {
		float note;
		float effect;
		float **cmap_note;
		float **cmap_effect;
	};

	trackdat trackd[MAX_TRACKS];

	int translate_note(float value) const {
		int midinote;

		midinote = (int)((log(value / 440.0f) / log(2.0f)) * 12.0f + 57.5f);
		midinote = ((midinote / 12) << 4) | ((midinote % 12) + 1);
		return 12 * (midinote >> 4) + (midinote & 0xf) - 1;
	}

	void init() {
		
		// Map controller placeholders to local variables for iterative convenience

		trackd[0].cmap_note = &(controllers->note01);
		trackd[0].cmap_effect = &(controllers->effect01);
		trackd[1].cmap_note = &(controllers->note02);
		trackd[1].cmap_effect = &(controllers->effect02);
		trackd[2].cmap_note = &(controllers->note03);
		trackd[2].cmap_effect = &(controllers->effect03);
		trackd[3].cmap_note = &(controllers->note04);
		trackd[3].cmap_effect = &(controllers->effect04);
		trackd[4].cmap_note = &(controllers->note05);
		trackd[4].cmap_effect = &(controllers->effect05);
		trackd[5].cmap_note = &(controllers->note06);
		trackd[5].cmap_effect = &(controllers->effect06);
		trackd[6].cmap_note = &(controllers->note07);
		trackd[6].cmap_effect = &(controllers->effect07);
		trackd[7].cmap_note = &(controllers->note08);
		trackd[7].cmap_effect = &(controllers->effect08);
		trackd[8].cmap_note = &(controllers->note09);
		trackd[8].cmap_effect = &(controllers->effect09);
		trackd[9].cmap_note = &(controllers->note10);
		trackd[9].cmap_effect = &(controllers->effect10);
		trackd[10].cmap_note = &(controllers->note11);
		trackd[10].cmap_effect = &(controllers->effect11);
		trackd[11].cmap_note = &(controllers->note12);
		trackd[11].cmap_effect = &(controllers->effect12);
		trackd[12].cmap_note = &(controllers->note13);
		trackd[12].cmap_effect = &(controllers->effect13);
		trackd[13].cmap_note = &(controllers->note14);
		trackd[13].cmap_effect = &(controllers->effect14);
		trackd[14].cmap_note = &(controllers->note15);
		trackd[14].cmap_effect = &(controllers->effect15);
		trackd[15].cmap_note = &(controllers->note16);
		trackd[15].cmap_effect = &(controllers->effect16);
	}

	void exit() {
		delete this;
	}

	void process_events() {
		int t;

		for(t = 0; t < track_count; t++) {
			if(tracks[t].note) {
				if (*tracks[t].note != 0)
					trackd[t].note = float(translate_note(*(tracks[t].note)));
				else
					trackd[t].note = 0;
			}
			if(tracks[t].effect) {
				trackd[t].effect = float(*tracks[t].effect);
			}
		}
	}

	void process_controller_events() {
		int t;
		for(t = 0; t < track_count; t++) {
			*(trackd[t].cmap_note) = (tracks[t].note) ? &trackd[t].note : 0;
			*(trackd[t].cmap_effect) = (tracks[t].effect) ? &trackd[t].effect : 0;
		}
	}
	
	void process_stereo(float *inL, float *inR, float *outL, float *outR, int n) {
	}

};

lunar_fx *new_fx() { return new note(); }
